<?php
/* Quiz 2.0 - quiz.php
 - Webbausteine.de */

include "quiz_config.php";

if (isset($quiz)) {
 $rnd = 'da4b9237bacccdf19c0760cab7aec4a8359010b0';
 if (!isset($_POST["save"])) {

  // Anzahl der Fragen ermitteln
  $select = $quizDB->query("SELECT `id`
                                           FROM `quizDB`
                                           WHERE `quiz` = '" . $quiz . "' AND `anzeige` = '1'");
  $fragen = count($select->fetchAll(PDO::FETCH_OBJ));

  // Anzahl der Frage erhöhen
  $frage = 0;
  if (isset($_POST["frage"])) {
   $frage = $_POST["frage"] += 1;
  }

  // Frage und Antworten auslesen
  if ($frage <= $fragen) {
   $select = $quizDB->query("SELECT `id`, `frage`, `aw1`, `aw2`, `aw3`, `aw4`, `aw5`, `aw6`, `aw7`, `loesung`
                                            FROM `quizDB`
                                            WHERE `quiz` = '" . $quiz . "' AND `anzeige` = '1'
                                            LIMIT " . $frage . ",1");
   $eintrag = $select->fetch();

   // Punkte vergeben
   $punkte = isset($_POST["punkte"]) ? substr($_POST["punkte"], strlen($rnd)) : 0;
   if (isset($_POST["aw"])) {
    if (sha1($_POST["aw"]) === $_POST["loesung"]) {
     $punkte++;

     // Lösung bei einer richtigen Antwort ausgeben
     if ($zeige_loesung == "ja") {
      echo '<p><span style="color: #3DCE00; font-weight: bold;">&#10004;</span> Die Antwort ist richtig.</p>';
     }
    }
    else {

     // Lösung bei einer falschen Antwort ausgeben
     if ($zeige_loesung == "ja") {
      $loesung = $quizDB->query("SELECT `id`, `frage`, `aw1`, `aw2`, `aw3`, `aw4`, `aw5`, `aw6`, `aw7`, `loesung`
                                               FROM `quizDB`
                                               WHERE `id` = '" . $_POST["id"] . "' AND `anzeige` = '1'");
      $ergebnis = $loesung->fetch();
      echo '<p><span style="color: #FF0000; font-weight: bold;">&#10008;</span> Die Antwort ist leider falsch,<br>' .
      'richtig wäre &bdquo;<i>' . $ergebnis["aw" . $ergebnis["loesung"]] . '</i>&rdquo; gewesen.</p>';
     }
    }
   }

   // Frage stellen
   if ($eintrag["frage"] != "" &&
       !isset($_POST["ende"])) {
    echo '<form action="" method="post">' .
     '<p class="zaehler">Frage ' . ($frage + 1) . ' von ' . $fragen . '</p>' .
     '<div class="frage">' . nl2br($eintrag["frage"]) . '</div>' .
     '<p class="antwort"><label><input type="radio" name="aw" value="1" required="required"> ' . $eintrag["aw1"] . '</label></p>' .
     '<p class="antwort"><label><input type="radio" name="aw" value="2"> ' . $eintrag["aw2"] . '</label></p>' .
     (($eintrag["aw3"] != "") ? '<p class="antwort"><label><input type="radio" name="aw" value="3"> ' . $eintrag["aw3"] . '</label></p>' : '') .
     (($eintrag["aw4"] != "") ? '<p class="antwort"><label><input type="radio" name="aw" value="4"> ' . $eintrag["aw4"] . '</label></p>' : '') .
     (($eintrag["aw5"] != "") ? '<p class="antwort"><label><input type="radio" name="aw" value="5"> ' . $eintrag["aw5"] . '</label></p>' : '') .
     (($eintrag["aw6"] != "") ? '<p class="antwort"><label><input type="radio" name="aw" value="6"> ' . $eintrag["aw6"] . '</label></p>' : '') .
     (($eintrag["aw7"] != "") ? '<p class="antwort"><label><input type="radio" name="aw" value="7"> ' . $eintrag["aw7"] . '</label></p>' : '') .
     '<input type="hidden" name="punkte" value="' . $rnd . $punkte . '">' .
     '<input type="hidden" name="loesung" value="' . sha1($eintrag["loesung"]) . '">' .
     '<input type="hidden" name="frage" value="' . $frage . '">' .
     '<input type="hidden" name="fragen" value="' . $fragen . '">' .
     '<input type="hidden" name="id" value="' . $eintrag["id"] . '">' .
     '<p><input type="submit" value="Weiter"></p>' .
    '</form>';
   }
   else {
    echo '<form action="" method="post">' .
     '<input type="hidden" name="punkte" value="' . $rnd . $punkte . '">' .
     '<input type="hidden" name="frage" value="' . $frage . '">' .
     '<input type="hidden" name="fragen" value="' . $fragen . '">' .
     '<p><input type="submit" name="ende" value="Weiter zur Auswertung"></p>' .
     '</form>';
   }
  }
  if (isset($_POST["ende"])) {

   // Auswertung
   $punkte = substr($_POST["punkte"], strlen($rnd));
   echo '<p>Sie haben <b>' . $punkte . '</b> '.
    ($punkte == 1 ? 'Frage' : 'Fragen') .' von <b>' .
    $_POST["fragen"] . '</b> richtig beantwortet.</p>';

   // Formular Bestenliste
   if ($punkte >= $max_punkte &&
       $bestenliste == "ja") {
    echo '<form action="" method="post">' .
     '<p><b>In die Bestenliste eintragen</b></p>' .
     '<p><label>Name: <input type="text" name="name" required="required"></label>' .
     '<input type="hidden" name="punkte" value="' . $_POST["punkte"] . '">' .
     '<input type="hidden" name="quiz" value="' . $quiz . '">' .
     '<input type="hidden" name="fragen" value="' . $_POST["fragen"] . '">' .
     '<input type="submit" name="save" value="OK"></p>' .
     '</form>';
    }
  }
 }
 else {

  // In die Bestenliste eintragen
  $_POST["name"] = substr(strip_tags($_POST["name"]), 0, 50);
  $punkte = substr($_POST["punkte"], strlen($rnd));
  $select = $userDB->prepare("SELECT `name`, `punkte` FROM `userDB`
                                              WHERE `quiz` = :quiz AND `name` = :name");
  $select->execute(array(
                                     ':quiz' => $_POST["quiz"],
                                     ':name' => $_POST["name"]));
  $user = $select->fetch();
  if ($user["name"] == $_POST["name"]) {
   if ($punkte > $user["punkte"]) {
    $update = $userDB->prepare("UPDATE `userDB`
                                                 SET `punkte` = :punkte, `datum` = :datum, `versuche` = `versuche`+1
                                                 WHERE `quiz` = :quiz AND `name` = :name");
   $update->execute(array(
                                            ':quiz' => $_POST["quiz"],
                                            ':name' => $_POST["name"],
                                            ':punkte' => $punkte,
                                            ':datum' => date("Y-m-d")));
   }
   echo '<p>Vielen Dank ' . $_POST["name"] . ', für die Teilnahme an diesem Quiz.</p>';
  }
  else {
   $insert = $userDB->prepare("INSERT INTO `userDB` (`name`, `quiz`,  `fragen`, `punkte`, `versuche`,`datum`) 
                                               VALUES (:name, :quiz, :fragen, :punkte, 1, :datum)");
   if ($insert->execute(array(
                                          ':name' => $_POST["name"],
                                          ':quiz' => $_POST["quiz"],
                                          ':fragen' => $_POST["fragen"],
                                          ':punkte' => $punkte,
                                          ':datum' => date("Y-m-d")))) {
    echo '<p>Vielen Dank ' . $_POST["name"] . ', für die Teilnahme an diesem Quiz.</p>';
   }
  }
 }

 // Quiz neu starten
 if ($_SERVER["REQUEST_METHOD"] == "POST") {
   echo '<p>&raquo; <a href="' . basename($_SERVER["SCRIPT_NAME"]) . '">Quiz neu starten</a></p>';
 }
}
else {
 exit;
}
?>