<?php
/* Quiz 2.0 - quiz_admin.php
 - Webbausteine.de */

session_start();
include "quiz_config.php";

// Anmeldung überprüfen
if (isset($_GET["anmeldung"])){
 if ($passwort === $_POST["passwort"]) {
  $_SESSION["Quiz2.0_admin"] = true;
 }
}

// Abmeldung
if (isset($_GET["abmelden"])) {
 unset($_SESSION["Quiz2.0_admin"]);
}
?><!DOCTYPE html>
<html lang="de">
 <head>
  <meta charset="UTF-8">
  <title>Quiz - Admin.</title>

  <style>
  body {
   font-family: Verdana, Arial, Sans-Serif;
   background: Whitesmoke;
  }

  textarea {
   font-family: Verdana, Arial, Sans-Serif;
  }

  a:link, a:visited {
   color: Royalblue;
  }

  span.pflichtfeld {
   font-size: 1rem;
   color: Red;
  }
  </style>

 </head>
<body>

<h3>Quiz - Admin.</h3>

<?php
if (!isset($_SESSION["Quiz2.0_admin"])) {
   print '<form action="quiz_admin.php?anmeldung" method="post">
  <p><label>Passwort: <input type="password" name="passwort" required="required" autofocus="autofocus"></label>
    <input type="submit" value="OK"></p>
  </form>';
}
else {

 // Quiz ermitteln
 $select = $quizDB->query("SELECT `quiz`
                                          FROM `quizDB`
                                          GROUP BY `quiz`");
 $quizes = $select->fetchAll(PDO::FETCH_OBJ);
 $quiz_array = array();
 echo '<form action="" method="get">' .
  '<p><label>Quiz: <select name="quiz"><option value="aktuell">&emsp;&emsp;Aktuell!</option>';
 foreach ($quizes as $quiz) {
  $quiz_array[] = $quiz->quiz;
  echo '<option value="' . $quiz->quiz . '"';
  if (isset($_GET["quiz"])) {
   if (rawurlDEcode($_GET["quiz"]) == $quiz->quiz) {
    echo ' selected="selected"';
   }
  }
  echo '>' . $quiz->quiz . '</option>';
 }
  echo '</select></label> <input type="submit" value="&gt;"> &emsp;' .
  '<a href="quiz_admin.php?neu">Neuer Eintrag</a>' .
  ' - <a href="quiz_admin.php?abmelden">Abmelden</a>' .
  '</p></form>';

 // Neuer Eintrag (Form)
 if (isset($_GET["neu"])) {
  echo '<form name="Form" action="quiz_admin.php" method="post" autocomplete="off">
   <fieldset>
    <legend>Neuer Eintrag</legend>
   <p><label>Quiz: <input type="text" name="quiz" size="55" list="datalist" required="required"></label> <span class="pflichtfeld">*</span>
   <datalist id="datalist"><option>' . implode('</option><option> ', $quiz_array) . '</option></datalist></p>
   <p><label><input type="checkbox" name="anzeige" checked="checked"> Quizfrage anzeigen</label></p>
   <p><label>Frage: <span class="pflichtfeld">*</span> <small>(HTML möglich!)</small><br>
   <textarea name="frage" rows="5" cols="50" required="required"></textarea></p>
   <p><label>Antwort 1: <input type="text" name="aw1" size="55" required="required"></label> <span class="pflichtfeld">*</span><br>
   <label>Antwort 2: <input type="text" name="aw2" size="55" required="required"></label> <span class="pflichtfeld">*</span><br>
   <label>Antwort 3: <input type="text" name="aw3" size="55"></label><br>
   <label>Antwort 4: <input type="text" name="aw4" size="55"></label><br>
   <label>Antwort 5: <input type="text" name="aw5" size="55"></label><br>
   <label>Antwort 6: <input type="text" name="aw6" size="55"></label><br>
   <label>Antwort 7: <input type="text" name="aw7" size="55"></label></p>
   <p><label>Lösung: <input type="number" name="loesung" value="1" min="1" max="7"
    required="required" style="width: 50px;"></label> <span class="pflichtfeld">*</span> <small>(Antwort 1 - 7)</small></p>
   <input type="submit" name="neu" value="Eintragen">
   </fieldset>
  </form>';
 }

 // Neuer Eintrag speichern
 if (isset($_POST["neu"])) {
  $update = $quizDB -> prepare("INSERT INTO `quizDB`(`quiz`, `anzeige`, `frage`, `aw1`, `aw2`, `aw3`, `aw4`, `aw5`, `aw6`, `aw7`, `loesung`)
                                                 VALUES (:quiz, :anzeige, :frage, :aw1, :aw2, :aw3, :aw4, :aw5, :aw6, :aw7, :loesung)");
  $anzeige = isset($_POST["anzeige"]) ? 1 : 0;
  if ($update->execute(array(
   ':quiz' => $_POST["quiz"], ':frage' => $_POST["frage"],
   ':aw1' => $_POST["aw1"], ':aw2' => $_POST["aw2"],
   ':aw3' => $_POST["aw3"], ':aw4' => $_POST["aw4"],
   ':aw5' => $_POST["aw5"], ':aw6' => $_POST["aw6"],
   ':aw7' => $_POST["aw7"], ':loesung' => $_POST["loesung"],
   ':anzeige' => $anzeige))) {
   echo '<p><span style="color: #00B1FF; font-weight: bold;">&#10149;</span> Der Eintrag wurde gespeichert.</p>';
  }
 }

 // Eintrag bearbeiten/löschen (Form)
 if (isset($_GET["bearbeiten"])) {
  $select = $quizDB->query("SELECT `id`, `quiz`, `anzeige`, `frage`, `aw1`, `aw2`, `aw3`, `aw4`, `aw5`, `aw6`, `aw7`, `loesung`
                                          FROM `quizDB`
                                          WHERE `id` = '" . $_GET["bearbeiten"] . "'");
  $eintrag = $select->fetch();
  $anzeigeCK = ($eintrag["anzeige"] == "1") ? ' checked="checked"' : '';
  echo '<form name="Form" action="quiz_admin.php?quiz=' . $_GET["quiz"] . '" method="post" autocomplete="off">
   <fieldset>
    <legend>Eintrag bearbeiten</legend>
   <p><label>Quiz: <input type="text" name="quiz" value="' . $eintrag["quiz"] . '" size="55" list="datalist" required="required"></label> <span class="pflichtfeld">*</span>
   <datalist id="datalist"><option>' . implode('</option><option> ', $quiz_array) . '</option></datalist></p>
   <p><label><input type="checkbox" name="anzeige"' . $anzeigeCK . '> Quizfrage anzeigen</label></p>
   <p><label>Frage:  <span class="pflichtfeld">*</span> <small>(HTML möglich!)</small><br>
   <textarea name="frage" rows="5" cols="50" required="required">' . $eintrag["frage"] . '</textarea></p>
   <p><label>Antwort 1: <input type="text" name="aw1" value="' . $eintrag["aw1"] . '" size="55" required="required"></label> <span class="pflichtfeld">*</span><br>
   <label>Antwort 2: <input type="text" name="aw2" value="' . $eintrag["aw2"] . '" size="55" required="required"></label> <span class="pflichtfeld">*</span><br>
   <label>Antwort 3: <input type="text" name="aw3" value="' . $eintrag["aw3"] . '" size="55"></label><br>
   <label>Antwort 4: <input type="text" name="aw4" value="' . $eintrag["aw4"] . '" size="55"></label><br>
   <label>Antwort 5: <input type="text" name="aw5" value="' . $eintrag["aw5"] . '" size="55"></label><br>
   <label>Antwort 6: <input type="text" name="aw6" value="' . $eintrag["aw6"] . '" size="55"></label><br>
   <label>Antwort 7: <input type="text" name="aw7" value="' . $eintrag["aw7"] . '" size="55"></label></p>
   <p><label>Lösung: <input type="number" name="loesung" value="' . $eintrag["loesung"] . '" min="1" max="7"
    required="required" style="width: 50px;"></label> <span class="pflichtfeld">*</span> <small>(Antwort 1 - 7)</small>
   <input type="hidden" name="id" value="' . $eintrag["id"] . '"></p>
   <label><input type="radio" name="option" value="edit" checked="checked">Ändern</label>
   <label><input type="radio" name="option" value="delete"> Löschen</label> &emsp; 
   <input type="submit" name="bearbeiten" value="Ausführen">
   </fieldset>
  </form>';
 }

 // Eintrag bearbeiten/löschen
 if (isset($_POST["bearbeiten"])) {
  if ($_POST["option"] == "edit") {
    $update = $quizDB -> prepare("UPDATE `quizDB`
                                                    SET `quiz` = :quiz, `anzeige` = :anzeige, `frage` = :frage,
                                                          `aw1` = :aw1, `aw2` = :aw2, `aw3` = :aw3, `aw4` = :aw4,
                                                          `aw5` = :aw5, `aw6` = :aw6, `aw7` = :aw7 , `loesung` = :loesung
                                                    WHERE `id` = :id");
    $anzeige = isset($_POST["anzeige"]) ? 1 : 0;
    if ($update->execute(array(
     ':quiz' => $_POST["quiz"], ':frage' => $_POST["frage"],
     ':aw1' => $_POST["aw1"], ':aw2' => $_POST["aw2"],
     ':aw3' => $_POST["aw3"], ':aw4' => $_POST["aw4"],
     ':aw5' => $_POST["aw5"], ':aw6' => $_POST["aw6"],
     ':aw7' => $_POST["aw7"], ':loesung' => $_POST["loesung"],
     ':anzeige' => $anzeige, ':id' => $_POST["id"]))) {
     echo '<p><span style="color: #00B1FF; font-weight: bold;">&#10149;</span> Der Eintrag wurde überschrieben.</p>';
    }
  }
  if ($_POST["option"] == "delete") {
   $delete = $quizDB->prepare("DELETE FROM `quizDB`
                                                WHERE `id` = :id");
   if ($delete->execute(array(':id' => $_POST["id"]))) {
    print '<p><span style="color: #00B1FF; font-weight: bold;">&#10149;</span> Der Eintrag wurde gelöscht.</p>';
   }
  }
 }

 // Aktuell
 if (isset($_GET["quiz"])) {
  if ($_GET["quiz"] == "aktuell") {
   echo '<h3>Aktuell</h3><p><b>Datenbank:</b> ' . $quizfile . '<br>' .
   '<b>Dateigröße:</b> ' . filesize($quizfile) . ' Bytes (' . number_format((filesize($quizfile)/1024), 2, ",", ".") . ' KB)<br>' .
   '<b>Änderung:</b> ' . date("d.m.Y - H:i", filemtime($quizfile)) . ' Uhr</p>' .
   '<p><b>Datenbank:</b> ' . $userfile . '<br>' .
   '<b>Dateigröße:</b> ' . filesize($userfile) . ' Bytes (' . number_format((filesize($userfile)/1024), 2, ",", ".") . ' KB)<br>' .
   '<b>Änderung:</b> ' . date("d.m.Y - H:i", filemtime($userfile)) . ' Uhr</p>';
  }
  else {
   // Eintrag zum bearbeiten auswählen
   echo '<p>';
   $select = $quizDB->query("SELECT `id`, `quiz`, `anzeige`, `frage`
                                           FROM `quizDB`
                                           WHERE `quiz` = '" . $_GET["quiz"] . "'");
   $quizlist = $select->fetchAll(PDO::FETCH_OBJ);
   foreach ($quizlist as $qlist) {
    echo ($qlist->anzeige =="1" ? '<span style="color: #3DCE00; font-weight: bold;">&#10004;</span>' : '<span style="color: #FF0000; font-weight: bold;">&#10008;</span>') .
     ' <a href="quiz_admin.php?quiz=' . rawurlENcode($qlist->quiz) . '&amp;bearbeiten=' . $qlist->id . '">' . substr(strip_tags($qlist->frage), 0, 80) . '</a><br>';
   }
   echo '</p>';
  }
 }
}
?>

</body>
</html>