<?php
/* Quiz 2.0 - quiz_config.php
 - Webbausteine.de */

// Passwort
$passwort = "0000";

// Lösung anzeigen (ja/nein)
$zeige_loesung = "ja";

// User in die Bestenliste eintragen lassen (ja/nein)
$bestenliste = "ja";

// Ab wieviel Punkte in die Bestenliste eintragen lassen
$max_punkte = 2;


// Datenbank-Dateien
$quizfile = 'daten/quizdb.sqt';
if (!file_exists($quizfile)) {
 $quizDB = new PDO('sqlite:' . $quizfile);
 $quizDB->exec("CREATE TABLE quizDB(
  `id` INTEGER PRIMARY KEY,
  `quiz` CHAR(50),
  `anzeige` INTEGER,
  `frage` TEXT,
  `aw1` TEXT,
  `aw2` TEXT,
  `aw3` TEXT,
  `aw4` TEXT,
  `aw5` TEXT,
  `aw6` TEXT,
  `aw7` TEXT,
  `loesung` INTEGER)");
 } else {
 $quizDB = new PDO('sqlite:' . $quizfile);
}

$userfile = 'daten/userdb.sqt';
if (!file_exists($userfile)) {
 $userDB = new PDO('sqlite:' . $userfile);
 $userDB->exec("CREATE TABLE userDB(
  `name` CHAR(50),
  `quiz` CHAR(50),
  `fragen` INTEGER,
  `punkte` INTEGER,
  `versuche` INTEGER,
  `datum` DATETIME)");
} else {
 $userDB = new PDO('sqlite:' . $userfile);
}


function user($quiz, $max) {
 global $userDB;
 $select = $userDB->query("SELECT `name`, `quiz`, `fragen`, `punkte`, `versuche`, `datum`
                                          FROM `userDB`
                                          WHERE `quiz` = '" . $quiz . "'
                                          ORDER BY `punkte` DESC
                                          LIMIT 0," . $max);
 $users = $select->fetchAll(PDO::FETCH_OBJ);

 if (count($users) > 0) {
    $text =  '<table border="1"><caption>' . $users[0]->quiz . '</caption><tr><th>Name</th><th>Punkte</th><th>Fragen</th><th>Versuche</th><th>Datum</th></tr>';
  foreach ($users as $user) {
   sscanf($user->datum, "%4s-%2s-%2s", $jahr, $monat, $tag);
   $text .=  '<tr><td>' . $user->name . '</td><td>' . $user->punkte . '</td><td>' . $user->fragen . '</td><td>' . $user->versuche . '</td><td>' . $tag . '.' . $monat . '.' . $jahr . '</td></tr>';
  }
  return $text . '</table>';
 }
 else {
  return '<p><span style="color: #FF0000; font-weight: bold;">&#10008;</span> Keine Daten zum Quiz: "' . $quiz . '" vorhanden!</p>';
 }
}
?>